#ifndef EFL_GENERATED_EVAS_SIGNAL_INTERFACE_HH
#define EFL_GENERATED_EVAS_SIGNAL_INTERFACE_HH

extern "C"
{
#include <Efl.h>
}
#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "evas_signal_interface.eo.h"
}


namespace evas {

struct signal_interface;

}

namespace eo_cxx {

namespace evas {

struct signal_interface
{

   static Eo_Class const* _eo_class()
   {
      return(EVAS_SIGNAL_INTERFACE_INTERFACE);
   }

   operator ::evas::signal_interface() const;
   operator ::evas::signal_interface&();
   operator ::evas::signal_interface const&() const;

   template <typename D>
   struct address_of
   {
      operator ::evas::signal_interface*() const { return static_cast<::evas::signal_interface*>(static_cast<D const*>(this)->p); }
      operator ::evas::signal_interface const*() const { return static_cast<::evas::signal_interface const*>(static_cast<D const*>(this)->p); }
   };

   template <typename D>
   struct address_const_of
   {
      operator ::evas::signal_interface const*() const { return static_cast<::evas::signal_interface const*>(static_cast<D const*>(this)->p); }
   };

private:
   Eo* _concrete_eo_ptr() const
   {
      return static_cast<::efl::eo::concrete const*>(static_cast<void const*>(this))->_eo_ptr();
   }

};

}

}

namespace evas {

struct signal_interface
      : ::efl::eo::concrete
{
   signal_interface(::efl::eo::parent_type _p = (::efl::eo::parent = nullptr))
      : signal_interface(_ctors_call(_p))
   {}

   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit signal_interface(Eo* eo)
      : ::efl::eo::concrete(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit signal_interface(std::nullptr_t)
      : ::efl::eo::concrete(nullptr)
   {}

   /// @brief Copy Constructor.
   ///
   signal_interface(signal_interface const& other)
      : signal_interface(eo_ref(other._eo_ptr()))
   {}

   ~signal_interface() {}


   static Eo_Class const* _eo_class()
   {
      return(EVAS_SIGNAL_INTERFACE_INTERFACE);
   }

   struct address_of
      : ::eo_cxx::evas::signal_interface::address_of<address_of>
      , ::efl::eo::detail::concrete_address_of
   {
      explicit address_of(::evas::signal_interface* p)
         : ::efl::eo::detail::concrete_address_of(p)
      {}
   };
   address_of operator&() { return address_of(this); }

   struct address_const_of
      : ::eo_cxx::evas::signal_interface::address_const_of<address_const_of>
      , ::efl::eo::detail::concrete_address_const_of
   {
      explicit address_const_of(::evas::signal_interface const* p)
         : ::efl::eo::detail::concrete_address_const_of(p)
      {}
   };
   address_const_of operator&() const { return address_const_of(this); }

private:
   static Eo* _ctors_call(::efl::eo::parent_type _p)
   {
      Eo* _ret_eo = eo_add_ref(EVAS_SIGNAL_INTERFACE_INTERFACE, _p._eo_raw, );

      return _ret_eo;
   }

      Eo* _concrete_eo_ptr() const { return _eo_ptr(); }
};

static_assert(sizeof(::evas::signal_interface) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<::evas::signal_interface>::value, "");

}

inline ::eo_cxx::evas::signal_interface::operator ::evas::signal_interface() const
{
   return *static_cast<::evas::signal_interface const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::evas::signal_interface::operator ::evas::signal_interface&()
{
   return *static_cast<::evas::signal_interface*>(static_cast<void*>(this));
}

inline ::eo_cxx::evas::signal_interface::operator ::evas::signal_interface const&() const
{
   return *static_cast<::evas::signal_interface const*>(static_cast<void const*>(this));
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::evas::signal_interface >
{
   template <typename T>
   struct type
   {
   };
};


template<>
struct operation_description_class_size< ::evas::signal_interface >
{
   static const int value = 0;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::evas::signal_interface>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   return 0;
}
inline void
call_constructor(::efl::eo::detail::tag< ::evas::signal_interface >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               ::efl::eo::detail::args_class<::evas::signal_interface, ::std::tuple<::efl::eo::parent_type> > const& args)
{
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

inline Eo_Class const* get_eo_class(tag<::evas::signal_interface>)
{
   return (EVAS_SIGNAL_INTERFACE_INTERFACE);
}

} } }
#endif // EFL_GENERATED_EVAS_SIGNAL_INTERFACE_HH

